> For the complete documentation index, see [llms.txt](https://docs.otland.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.otland.net/lua-guide/concepts/memoization.md).

# Memoization

Memoization is a programming technique to basically "cache" expensive procedures or operations in order to avoid evaluating their results again.

Take this function for example, to generate a character list starting from lowercase chars up to a certain character code:

```lua
local mem = {}

function generateCharlist(n)
	if mem[n] then
		return mem[n]
	end
	local str = ''
	for i = 97, 97+n do -- start from lowercase
		str = str .. string.char(i) -- convert number to character
	end
	mem[n] = str
	return str
end

local firstList = generateCharlist(25) -- performs the generation
local secondList = generateCharlist(25) -- uses the pre-generated value

print(firstList, secondList) -- abcdefghijklmnopqrstuvwxyz	abcdefghijklmnopqrstuvwxyz
```

Here once `generateCharlist` is called the first time, that string is generated and inserted into the `mem` table, the next time it runs with the exact same param as the first call, it will use the pre-generated value rather than having to spend the time generating it again.

Do not use that code as a good "optimized" example of that process (specifically lines 7-10), since I intended for it to perform poorly. More info about why this is awful to do can be found in the [Optimizations](/lua-guide/auxiliary/optimizations.md) page.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.otland.net/lua-guide/concepts/memoization.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
